//+------------------------------------------------------------------+
//|                                                      Leader MACD |
//|                                                   LeaderMACD.mq4 |
//|                                                           mladen |
//|                                                                  |
//| TASC jul 2008                                                    |
//| Giorgos Siligardos                                               |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  OrangeRed
#property indicator_color3  Goldenrod
#property indicator_width1  2

//
//
//
//
//

extern int  FastEMA        = 12;
extern int  SlowEMA        = 26;
extern int  SignalEMA      =  9;
extern bool SignalOnLeader = false;
extern bool ShowMACD       = true;
extern bool ShowSignal     = true;
extern int  ApplyTo        = PRICE_CLOSE;


//
//
//
//
//

double macd[];
double leader[];
double signal[];
double tBuffer[][5];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if (!ShowMACD) SignalOnLeader = true;
   
      //
      //
      //
      //
      //
      
   SetIndexBuffer(0,macd);
   SetIndexBuffer(1,leader);
   SetIndexBuffer(2,signal);
   IndicatorShortName("Leader MACD ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iFastEma 0
#define iSlowEma 1
#define iFastEmx 2
#define iSlowEmx 3
#define iSmoothl 4

int start()
{
   int i,r,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            limit=Bars-counted_bars;
            if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);
 
   //
   //
   //
   //
   //
 
   double alphaFast = 2.0 / (1.0+FastEMA);
   double alphaSlow = 2.0 / (1.0+SlowEMA);
   double alphaSign = 2.0 / (1.0+SignalEMA);
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,ApplyTo,i);
      
         tBuffer[r][iFastEma] = iMA(NULL,0,FastEMA,0,MODE_EMA,ApplyTo,i);
         tBuffer[r][iSlowEma] = iMA(NULL,0,SlowEMA,0,MODE_EMA,ApplyTo,i);
         tBuffer[r][iFastEmx] = tBuffer[r-1][iFastEmx] + alphaFast*(price-tBuffer[r][iFastEma]-tBuffer[r-1][iFastEmx]);
         tBuffer[r][iSlowEmx] = tBuffer[r-1][iSlowEmx] + alphaSlow*(price-tBuffer[r][iSlowEma]-tBuffer[r-1][iSlowEmx]);
         
         //
         //
         //
         //
         //
         
         leader[i] = tBuffer[r][iFastEma] + tBuffer[r][iFastEmx] - tBuffer[r][iSlowEma] - tBuffer[r][iSlowEmx];
                     tBuffer[r][iSmoothl] = tBuffer[r-1][iSmoothl] + alphaSign*(leader[i]-tBuffer[r-1][iSmoothl]);
 
         //
         //
         //
         //
         //
                             
         if (ShowMACD) macd[i] = tBuffer[r][iFastEma]-tBuffer[r][iSlowEma];
         if (ShowSignal)                                   
         if (SignalOnLeader)                     
               signal[i] = leader[i]-tBuffer[r][iSmoothl];
         else  signal[i] = signal[i+1] + alphaSign*(macd[i]-signal[i+1]);
   }                  
   return(0);
}